/* DeleteWorkStatus.java
 */

import java.lang.NumberFormatException;

/* DeleteWorkStatus
 */
public class DeleteWorkStatus extends ConsoleStatus {

	// tB[h
	private PersonList pl;
	private WorkList wl;
	private int id = -1;
	private String data;
	private WorkList selectedWl = null;

	/**
	 * RXgN^ DeleteWorkStatus
	 * @param String firstMess
	 * @param String promptMess
	 * @param boolean IsEndStatus
	 * @param PersonList pl
	 * @param WorkList wl
	 */
	DeleteWorkStatus( String firstMess, String promptMess,
	                 boolean IsEndStatus, PersonList pl, WorkList wl ) {
		super( firstMess, promptMess, IsEndStatus );
		this.pl = pl;
		this.wl = wl;
		this.id = -1;
		this.data = "";
		this.selectedWl = null;
	}

	// ŏɏo͂郁bZ[W\
	// ̃NXł͉ғ̃f[^̍폜
	// ݂̂s
	/** displayFirstMess
	 * @throws Exception
	 */
	public void displayFirstMess() throws Exception {
		String	comma;
		// ID̓
		System.out.print( "]ƈID͂ĂB\n>" );
		data = inputMessage();
		try {
			id = Integer.parseInt( data ); // ]ƈID
		} catch( NumberFormatException e ) {
			System.out.println( "lɕϊłȂf[^͂Ă܂B" );
			System.out.println( "ē͂ĂB" );
			displayFirstMess();
			return;
		}

		Person p = pl.get( id );
		if( p == null ) {
			System.out.println( "wID̏]ƈ݂͑܂B" );
			System.out.println( "ē͂ĂB" );
			displayFirstMess();
			return;
		}

		selectedWl = wl.searchByPersonID( p.getID() );
		// w肵]ƈID̏]ƈ蓖ĂĂ
		// ғ̕\
		selectedWl.displayWithClient();

		System.out.print( "폜ғID͂ĂB\n[" );
		comma = "";
		for( int idx = 0; idx < wl.size(); idx++ ) {
			Work w = selectedWl.get( idx );

			// idx̒lƓғID̃R[hȂꍇC΂
			if( w == null ) continue;
			System.out.print( comma + w.getID() );
			comma = ",";
		}
		System.out.print( "]>" );
		data = inputMessage();
		try {
			id = Integer.parseInt( data ); // 폜ғID
		} catch( NumberFormatException e ) {
			id = -1;
		}
	}

	// Y͂ꂽꍇw肳ꂽR[h폜C
	// N(܂͂ȊO)̏ꍇ
	// ԂɑJڂ悤ɂĂ
	/** getNextStatus
	 * @param String s
	 * @return ConsoleStatus
	 */
	public ConsoleStatus getNextStatus( String s ) {
		if( s.equals( "Y" ) ) {
			wl.delete( id );
			System.out.println( "폜܂B" );
		}

		return super.getNextStatus( " " );
	}
}
