/* UpdatePersonStatus.java
 */

import java.io.IOException;

/* UpdatePersonStatus
 */
public class UpdatePersonStatus extends ConsoleStatus {

	// tB[h
	private PersonList pl;

	private String[] messages = {
		"1.\t\t\t2.Z\n",
		"3.dbԍ\t\t4.E\n",
		"5.ΑN\t\t6.P\n"
	};
	private String data;

	/**
	 * RXgN^ UpdatePersonStatus
	 * @param String firstMess
	 * @param String promptMess
	 * @param boolean IsEndStatus
	 * @param PersonList pl
	 */
	UpdatePersonStatus( String firstMess, String promptMess,
	                 boolean IsEndStatus, PersonList pl ) {
		super( firstMess, promptMess, IsEndStatus );
		this.pl = pl;
		this.data = "";
	}

	// ŏɏo͂郁bZ[W\
	// ̃NXł͏]ƈ̃f[^̍XV
	// ݂̂s
	/** displayFirstMess
	 * @throws IOException
	 */
	public void displayFirstMess() throws IOException {
		int id, no, num;

		// ID̓
		System.out.print( "]ƈID͂ĂB\n>" );
		data = inputMessage();
		try {
			id = Integer.parseInt( data ); // ]ƈID
		} catch( NumberFormatException e ) {
			System.out.println( "lɕϊłȂf[^͂Ă܂B" );
			System.out.println( "ē͂ĂB" );
			displayFirstMess();
			return;
		}

		Person p = pl.get( id );
		if( p == null ) {
			System.out.println( "wID̏]ƈ݂͑܂B" );
			System.out.println( "ē͂ĂB" );
			displayFirstMess();
			return;
		}

		// ]ƈ̏̏o
		System.out.println( p.toString() );
		
		System.out.println( "\nXVڂ͂ĂB" );
		// messages̊eɕ\
		for( int idx = 0; idx < messages.length; idx++ )
			System.out.print( messages[ idx ] );

		// XV鍀ڂ̔ԍ̓
		System.out.print( "\nXV鍀ڂ̔ԍ͂ĂB\n>" );
		data = inputMessage();

		try {
			no = Integer.parseInt( data ); // XV鍀ڂ̔ԍ

			// XVl̓
			System.out.print( "\nXV̒l͂ĂB\n>" );
			data = inputMessage();

			if( no == 5 || no == 6 ) {
				num = Integer.parseInt( data ); // ΑN܂͒P
				if( no == 5 )
					p.setWorkingYears( num );
				else
					p.setPrice( num );
			}
			else if( no >= 1 && no <= 4 ) {
				switch( no ) {
					case 1:
						p.setName( data );   break;
					case 2:
						p.setAddress( data );   break;
					case 3:
						p.setTel( data );   break;
					case 4:
						p.setType( data );   break;
					default:
						break;
				}
			}
		} catch( NumberFormatException e ) {
			System.out.println( "lɕϊłȂf[^͂Ă܂B" );
			System.out.println( "ē͂ĂB" );
			displayFirstMess();
			return;
		}
	}

	// ̏ԂɑJڂ邱Ƃ𑣂߂̃bZ[W̕\
	// ̃NX́CԂɖ߂ƌ܂Ă邽߁C
	// ͂ĂԂɑJڂ悤ɂĂ
	/** getNextStatus
	 * @param String s
	 * @return ConsoleStatus
	 */
	public ConsoleStatus getNextStatus( String s ) {
		return super.getNextStatus( " " );
	}
}
