/* ClientList.java
 */

import java.util.List;
import java.util.ArrayList;

/* ClientList <- RecordListC^tF[X
 */
public class ClientList implements RecordList {

	/**
	 * tB[h
	 */
	private List<Client> list;

	/**
	 * RXgN^ ClientList
	 */
	ClientList() {
		this.list = new ArrayList<Client>();
	}

	/** RXgN^ ClientList
	 * @param List<Client> al
	 */
	ClientList( List<Client> al ) {
		this.list = al;
	}

	/** size
	 * @return int
	 */
	public int size() {
		return list.size();
	}

	/** add
	 * @param String data
	 * @throws Exception
	 */
	public void add( String data ) throws Exception {
		Client p = new Client( data );
		for( int idx = 0; idx < list.size(); idx++ ) {
			Client pidx = list.get( idx );
			if( pidx.getID() == p.getID() )   // ID̃R[hꍇ
				return;                       // I
			else if( pidx.getID() > p.getID() ) {
				list.add( idx, p );           // R[hǉ
				return;
			}
		}
		list.add( p );    // XgɃR[hǉ
	}

	/** getRecord
	 * @param int idx
	 * @return Record
	 */
	public Record getRecord( int idx ) {
		if( idx >= list.size() )
			return null;
		else
			return list.get( idx );
	}

	/**
	 * allDisplay
	 */
	public void allDisplay() {
		for( Client p : list ) {
			System.out.println( p.toString() );
		}
	}

	/** find
	 * @param int ID
	 * @return int
	 */
	public int find( int ID ) {
		// IDƓIDR[ḧʒu
		for( int idx = 0; idx < list.size(); idx++ ) {
			Client pidx = list.get( idx );
			if( pidx.getID() == ID )
				return idx;
		}

		return -1;
	}

	/** get
	 * @param int ID
	 * @return Client
	 */
	public Client get( int ID ) {
		// IDƓIDR[h݂Ȃ΁C
		// ̃R[hԂ
		int idx;
		if( (idx = find( ID )) != -1 )
			return list.get( idx );
		else
			return null;
	}
}
