/* DisplayPersonsByTypeStatus.java
 */

/* DisplayPersonsByTypeStatus
 */
public class DisplayPersonsByTypeStatus extends ConsoleStatus {

	// tB[h
	private String work;
	private PersonList plist;
	private PersonList selectedList;
	private DisplayPersonStatus next;

	/**
	 * RXgN^ DisplayPersonsByTypeStatus
	 * @param String firstMess
	 * @param String promptMess
	 * @param boolean IsEndStatus
	 * @param PersonList plist
	 * @param DisplayPersonStatus next
	 */
	DisplayPersonsByTypeStatus( String firstMess, String promptMess,
	                     boolean IsEndStatus,
	                     PersonList plist, DisplayPersonStatus next ) {
		super( firstMess, promptMess, IsEndStatus );
		this.work = "";
		this.plist = plist;
		this.selectedList = null;
		this.next = next;
	}

	// ŏɏo͂郁bZ[W\
	/** displayFirstMess
	 * @throws Exception
	 */
	public void displayFirstMess() throws Exception {
		displayList();
		super.displayFirstMess();
	}

	/** setWork
	 * @param String work
	 */
	public void setWork( String work ) {
		this.work = work;
	}

	// ͂ꂽE]ƈ̃R[h
	// o
	/**
	 * displayList
	 */
	public void displayList() {
		// ͂ꂽE]ƈ̃R[h
		// selectedListɎo
		selectedList = plist.searchByTypes( work );
		// selectedLisť0ȂΓYE
		// ]ƈ͂Ȃƕ\
		if( selectedList.size() <= 0 )
			System.out.println( "]ƈ݂܂B" );
		else
			selectedList.allDisplay();
	}

	// ̏ԂɑJڂ邱Ƃ𑣂߂̃bZ[W̕\
	/** getNextStatus
	 * @param String s
	 * @return ConsoleStatus
	 */
	public ConsoleStatus getNextStatus( String s ) {
		// l͂ꂽꍇC̐lƓID
		// R[hselectedListɂ邩ǂ肵C
		// ΂̏DisplayPersonStatusɓn
		try {
			int i = Integer.parseInt( s );
			Person p = selectedList.get( i );
			if( p == null )
				return this;
			else {
				next.setPersonRecord( p );
				return next;
			}
		} catch( NumberFormatException e ) {
			return super.getNextStatus( s );
		}
	}
}
