/* NameSelectionStatus.java
 */

import java.io.IOException;

/* NameSelectionStatus
 */
public class NameSelectionStatus extends ConsoleStatus {

	// tB[h
	private DisplayPersonsByNameStatus next;

	/**
	 * RXgN^ NameSelectionStatus
	 * @param String firstMess
	 * @param String promptMess
	 * @param boolean IsEndStatus
	 * @param DisplayPersonsByNameStatus next
	 */
	NameSelectionStatus( String firstMess, String promptMess,
	                     boolean IsEndStatus, 
	                     DisplayPersonsByNameStatus next ) {
		super( firstMess, promptMess, IsEndStatus );
		this.next = next;
	}

	// ̏ԂɑJڂ邱Ƃ𑣂߂̃bZ[W̕\
	/** inputMessage
	 * @throws IOException
	 * @return String
	 */
	public String inputMessage() throws IOException {
		String mess = super.inputMessage();
		next.setName( mess );

		return mess;
	}

	// ̃NX́CDisplayPersonsByNameStatusĂԂ
	// ܂Ă邽߁C͂Ă
	// DisplayPersonsByNameStatusɑJڂ悤ɂĂ
	/** getNextStatus
	 * @param String s
	 * @return ConsoleStatus
	 */
	public ConsoleStatus getNextStatus( String s ) {
		return next;
	}
}
