/* SystemManager.java
 */

/* SystemManager
 */
public class SystemManager {
	/**
	 * tB[h
	 */
	private PersonList plist;  // ]ƈ̃Xg
	private ClientList clist;  // ڋq̃Xg
	private WorkList wlist;    // ғ̃Xg

	private String pfilename = "person.csv";
	private String cfilename = "client.csv";
	private String wfilename = "work.csv";

	private ConsoleStatus sts1, sts2;
	private DisplayPersonStatus sts5, sts5_2;
	private DisplayPersonsByTypeStatus sts4;
	private TypeSelectionStatus sts3;
	private DisplayPersonsByNameStatus sts7;
	private NameSelectionStatus sts6;
	private AddPersonStatus sts8;
	private UpdatePersonStatus sts9;
	private DeletePersonStatus sts10;
	private AddWorkStatus sts11;
	private DeleteWorkStatus sts12;
	private ExitStatus sts13;

	public static void main( String[] args ) {
		try {
			SystemManager manager = new SystemManager();

			manager.load();
			manager.run();
			manager.save();

		} catch ( Exception e ) {
			e.printStackTrace();
			System.exit( 0 );
		}
	}

	/**
	 * RXgN^ SystemManager
	 */
	SystemManager() {

		// ]ƈCڋqCғ̊eXg쐬
		this.plist = new PersonList();
		this.clist = new ClientList();
		this.wlist = new WorkList( this.clist );

		statusSetting();
	}

	// ԑJڂ̐ݒ
	/**
	 * statusSetting
	 */
	public void statusSetting() {

		// VXeŃC@\Ȉ
		sts1 = new ConsoleStatus(
		    "_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/\n" +
		    "            ]ƈhǗVXe\n" +
		    "                j[\n" +
		    "  ]ƈ(S)\n" +
		    "  ]ƈǗ(JIFǉ JUFXV JDF폜)\n" +
		    "  ғ󋵊Ǘ(KIFǉ KDF폜)\n" +
		    "  I(X)\n" +
		    "_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/\n",
		    "ǂ̋@\s܂H\n[S,JI,JU,JD,KI,KD,X]>",
		    false
		 );
		// N"S"͎̏
		sts2 = new ConsoleStatus(
		    "@w肵ĂB\n" +
                    "N->猟      T->E킩猟\n" +
                    "E->]ƈI(j[ɖ߂)",
                    "[N,T,E]>",
		    false
		 );

		// ]ƈID͂Ə\
		sts5 = new DisplayPersonStatus(
		    "",
		    "G^[L[ƌʈꗗɖ߂܂B\n>",
		    false,
		    wlist
		 );
		sts5_2 = new DisplayPersonStatus(
		    "",
		    "G^[L[ƌʈꗗɖ߂܂B\n>",
		    false,
		    wlist
		 );

		// E킩瓾]Ǝ҃Xg\C]ƈID͂
		sts4 = new DisplayPersonsByTypeStatus(
		    "",
		    "E->ʈꗗIiwɖ߂j[(]ƈID),E]>",
		    false,
		    plist,
		    sts5
		 );

		// E햼͂
		sts3 = new TypeSelectionStatus(
		    "E햼͂ĂB\n",
		    "[(E햼)]>",
		    false,
		    sts4
		 );

		// 瓾]Ǝ҃Xg\C]ƈID͂
		sts7 = new DisplayPersonsByNameStatus(
		    "",
		    "E->ʈꗗIiwɖ߂j[(]ƈID),E]>",
		    false,
		    plist,
		    sts5_2
		 );

		// ]ƈ̎͂
		sts6 = new NameSelectionStatus(
		    "͂ĂB\n",
		    "[()]>",
		    false,
		    sts7
		 );

		// ]ƈǉ
		sts8 = new AddPersonStatus(
		    "",
		    "G^[L[ƃj[ɖ߂܂B>",
		    false,
		    plist
		 );

		// ]ƈ̏XV
		sts9 = new UpdatePersonStatus(
		    "",
		    "XV܂B\nG^[L[ƃj[ɖ߂܂B>",
		    false,
		    plist
		 );

		// ]ƈ폜
		sts10 = new DeletePersonStatus(
		    "",
		    "̏]ƈ폜܂HiY ͂  N j[Y,N]>",
		    false,
		    plist
		 );

		// ғǉ
		sts11 = new AddWorkStatus(
		    "",
		    "G^[L[ƃj[ɖ߂܂B>",
		    false,
		    clist, wlist
		 );

		// ғ폜
		sts12 = new DeleteWorkStatus(
		    "",
		    "̉ғ폜܂HiY ͂  N j[Y,N]>",
		    false,
		    plist, wlist
		 );

		// VXeI
		sts13 = new ExitStatus(
		    "",
		    "",
		    true
		 );

		sts1.setNextStatus( "S", sts2 );
		sts1.setNextStatus( "JI", sts8 );
		sts1.setNextStatus( "JU", sts9 );
		sts1.setNextStatus( "JD", sts10 );
		sts1.setNextStatus( "KI", sts11 );
		sts1.setNextStatus( "KD", sts12 );
		sts1.setNextStatus( "X", sts13 );

		sts2.setNextStatus( "N", sts6 );
		sts2.setNextStatus( "T", sts3 );
		sts2.setNextStatus( "E", sts1 );

		sts4.setNextStatus( "E", sts2 );

		sts5.setNextStatus( " ", sts4 );
		sts5_2.setNextStatus( " ", sts7 );

		sts7.setNextStatus( "E", sts2 );

		sts8.setNextStatus( " ", sts1 );

		sts9.setNextStatus( " ", sts1 );

		sts10.setNextStatus( " ", sts1 );

		sts11.setNextStatus( " ", sts1 );

		sts12.setNextStatus( " ", sts1 );
	}

	// VXe̋N
	/** run
	 * @throws Exception
	 */
	public void run() throws Exception {
		// C[`
		ConsoleStatus sts = sts1;
		String cmd;

		while( !sts.getIsEndStatus() ) {
			// ŏɏo͂郁bZ[W
			sts.displayFirstMess();
			// ̏ԂɑJڂ邱Ƃ𑣂߂̃bZ[W
			sts.displayPromptMess();
			// L[͂󂯕t
			cmd = sts.inputMessage();
			// L[͂ꂽR}hɂāC
			// ̏ԂɑJڂ
			sts = sts.getNextStatus( cmd );
		}

		// IԂɂȂC̎|̃bZ[Wo͂
		// Iiۑjs
		sts.displayFirstMess();
	}

	// }X^t@C̓Ǎ
	/** load
	 * @throws Exception
	 */
	public void load() throws Exception {
		// eCSVt@C烌R[hǂݎ
		FileLoader pload = new FileLoader( pfilename );
		FileLoader cload = new FileLoader( cfilename );
		FileLoader wload = new FileLoader( wfilename );

		pload.read( plist );
		cload.read( clist );
		wload.read( wlist );
	}

	// }X^t@C̕ۑ
	/** save
	 * @throws Exception
	 */
	public void save() throws Exception {
		FileSaver psave = new FileSaver( pfilename );
		FileSaver csave = new FileSaver( cfilename );
		FileSaver wsave = new FileSaver( wfilename );

		psave.write( plist );
		csave.write( clist );
		wsave.write( wlist );
	}
}
